<template>
    <input :type="type" v-if="['text','password','number','email','url','tel','month'].includes(type)" class="py-1 px-2 rounded-md shadow-sm dark:shadow-light-sm text-gray-700 dark:text-gray-300 dark:bg-gray-700 focus:outline-none focus:shadow-outline" :value="value" @keyup.enter.prevent="$emit('submit')" @keydown="filter" @input="$emit('input', $event.target.value)" ref="input">
    <textarea v-else-if="type=='textarea'" :rows="value.split(/\r\n|\r|\n/).length" class="py-1 px-2 rounded-md shadow-sm dark:shadow-light-sm text-gray-700 dark:text-gray-300 dark:bg-gray-700 focus:outline-none focus:shadow-outline" :value="value" @keydown="filter" @input="$emit('input', $event.target.value)" ref="input" />
    <div v-else class="text-red-500">Not Supported Input Type</div>
</template>

<script>
    export default {
        props: {
            value: {
                type: String,
                default: '',
            },
            type: {
                type: String,
                default: 'text',
            },
            filter: {
                type: Function,
                default: (e) => true,
            },
        },

        methods: {
            focus() {
                this.$refs.input.focus()
            },
        }
    }
</script>

